void SoftWareUart_Init()
{
  SoftWare_Uart_Tx=1;
  SoftWare_Uart_Rx=1;
  SoftWare_Uart_Tx_Direction=0;
  SoftWare_Uart_Rx_Direction=1;

  SoftWare_Uart_Tx=1;//ensure idel state for standard
  delay_us(BITPERIOD);
}


void Tx_Byte(unsigned char Data)
{
  char mask;
  SoftWare_Uart_Tx = 0;//replace by one for inverted
  delay_us(BITPERIOD);

  for (mask=0x01;mask!=0;mask=mask<<1)
  {
    if(Data&mask) SoftWare_Uart_Tx = 1;//replace by zero for inverted
    else SoftWare_Uart_Tx = 0;//replace by one for inverted
    delay_us(BITPERIOD);
  }
  SoftWare_Uart_Tx = 1;//replace by zero for inverted
  delay_us(BITPERIOD);
}

unsigned char Rx_Byte()
{
  char mask;
  char Data;
  Data=0;
  while(SoftWare_Uart_Rx);//replace by (!SoftWare_Uart_Rx) for inverted
  delay_us(HALFBITPERIOD);
  for(mask=0x01;mask!=0;mask=mask<<1)
  {
    delay_us(BITPERIOD);
    if(SoftWare_Uart_Rx)Data=Data|mask;//replace by (!SoftWare_Uart_Rx) for inverted
  }
  Delay_us(BITPERIOD);
  return Data;
}


void SoftUart_Print(char* Text)
{
 while(*Text)Tx_Byte(*Text++);
}


void SoftUart_PrintLine(char* Text)
{
 while(*Text)Tx_Byte(*Text++);
 Tx_Byte('\r');Tx_Byte('\n');
}



void SoftUart_PrintConst(const char* Text)
{
 while(*Text)Tx_Byte(*Text++);
}




void SoftUart_PrintConstLine(const char* Text)
{
 while(*Text)Tx_Byte(*Text++);
 Tx_Byte('\r');Tx_Byte('\n');
}





void SoftUart_ScanText(char* Buffer, char StopChar)
{
 while(*(Buffer-1)!=StopChar)
 {
   *Buffer++=Rx_Byte();
 }
 *--Buffer='\0';
}

void SoftUart_PrintNChar(char* Buffer, char Size)
{
 char i;
 for(i=0;i<Size;i++)
 Tx_Byte(Buffer[i]);
}

void SoftUart_PrintNCharLine(char* Buffer, char Size)
{
 char i;
 for(i=0;i<Size;i++)
 Tx_Byte(Buffer[i]);

 Tx_Byte('\r');
 Tx_Byte('\n');
}

unsigned char SoftWareUart_GetChar()
{
  return Rx_Byte();
}

void SoftWareUart_PutChar(char DataByte)
{
  Tx_Byte(DataByte);
}